<?php

/*
   Sunrise and sunset table for today at the given
   longitude and time zone offset from UTC.

   The date is taken from the system clock and depends
   on the time zone of the server running the program.

   This program uses the native PHP

   Author  : Jay Tanner
   License : Public Domain

*/

   OB_Start();

// Define the program cookie name and set it to expire in 30 days.
// This cookie can be shared by other programs in the same common
// home folder together.

   $CookieName = 'Sunrise_and_Sunset_Table_For_Today';
   $SetToExpireIn30Days = time() + 30*86400;

// Define script path and filename.
   $_AUTHOR_          = 'Jay Tanner';
   $_PROGRAM_VERSION_ = ''; $at = "&#97;&#116;"; $UTC = "&#85;&#84;&#67";
   $_SCRIPT_PATH_     = Filter_Input(INPUT_SERVER, 'SCRIPT_FILENAME');
   $_RUN_             = Filter_Input(INPUT_POST, 'SCRIPT_NAME');

// Define internal document page title, HTML page heading text and revision date
   $_INTERNAL_TITLE_  = "Sunrise and Sunset Table For Today";
   $_INTERFACE_TITLE_ = "<span style='font-size:150%;'>Latitudinal Sunrise and Sunset Table For Today</span><br><span style='font-size:100%;'>PHP Program by Jay Tanner</span>";
   $_REVISION_DATE_   = $_PROGRAM_VERSION_ .'Revised: '. GMDate("l, F d, Y $at h:i:s A   $UTC", FileMTime($_SCRIPT_PATH_));

// Define main TextArea text, background
// colors and HTML table row span.
   $TxColor = 'black';
   $BgColor = 'white';
   $ColSpan = 2;





// Do this only if [COMPUTE] button was clicked.
   $w = Filter_Input(INPUT_POST, 'ComputeButton');
   if (!IsSet($w))

// ----------------------------------------------------
// If [COMPUTE] button was clicked and an active cookie
// exists, then restore the previous interface settings
// from it.
     {
      $w = Filter_Input(INPUT_COOKIE, $CookieName);
   if (IsSet($w))
      {
       $CookieDataString = Filter_Input(INPUT_COOKIE, $CookieName);
        list
       (
        $LonDeg, $TZHHMM
       ) = Preg_Split("[\|]", $CookieDataString);

      }

   else

// Set the initial default interface startup values.

 {
  $LonDeg = '-76.000';
  $TZHHMM = '-05:00';

// Store interface settings in cookie.
   $CookieDataString = "$LonDeg|$TZHHMM";
   setcookie ($CookieName, $CookieDataString, $SetToExpireIn30Days);
  }
      } // End of  if (!isset(_POST['ComputeButton']))







// =======================================
// Read values of all interface arguments.
// Empty values are set to zero by default.

   $w = Filter_Input(INPUT_POST, 'ComputeButton');
   if (isset($w))
{
   $LonDeg = trim(Filter_Input(INPUT_POST, 'LonDeg'));
   if ($LonDeg == '') {$LonDeg = '-76';}
   if (!Is_Numeric($LonDeg)) {$LonDeg = '0.0';}

   $TZHHMM = trim(Filter_Input(INPUT_POST, 'TZHHMM'));
   if ($TZHHMM == '') {$TZHHMM = '+00:00';}

   $TZHHMM   = Num_to_HMS($TZHHMM);
   $TZHours  = HMS_to_Hours($TZHHMM);
   $TZHHMMSS = Hours_to_HMS($TZHours, 0, '+', ':');
   $TZHHMM   = substr($TZHHMMSS,0,6);

// Check for invalid time and replace with '+00:00'.
   if(Is_Valid_Time($TZHHMM) === FALSE){$TZHHMM = '+00:00';}





// ------------------------------------
// Store interface arguments in cookie.

   $CookieDataString = "$LonDeg|$TZHHMM";
   SetCookie ($CookieName, $CookieDataString, $SetToExpireIn30Days);
}




// ========================================
// Check for error. FALSE = Error detected.
// Change this code to detect errors.

   $ErrFlag = TRUE;






// ================================
// Check if error (FALSE) detected.

if ($ErrFlag === FALSE)
 {
  $TxColor = 'white';
  $BgColor = '#CC0000';

  $TextArea1Text =
"=== ERROR ====================================================================

$ErrMssg";
 }

else

// ===================================================
// Begin computations here if no error detected above.

  {

   $SunRiseSunSetTable = Sunrise_Sunset_Table_For_Today ($LonDeg, $TZHHMM);

// Print table to TextArea1
   $TextArea1Text =
"$SunRiseSunSetTable";
  }


// Determine the number of text rows to use in output TextArea1.
   $TextArea1Rows = 2 + substr_count($TextArea1Text, "\n");



print <<< _HTML

<!DOCTYPE='HTML'>
<HTML lang='en'>

<head>
<title>Sunrise/Sunset Table For Today</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<meta name="description" content="Computes a table of sunrise/sunset for today by latitude, longitude and time zone.">
<meta name="keywords" content="sunrise table,sunset table,sunrise,sunset">
<meta name="author" content="Jay Tanner - https://www.PHPScienceLabs.com">
<meta http-equiv="pragma"  content="no-cache">
<meta http-equiv="expires" content="-1">
<meta name="robots"    content="index,follow">
<meta name="googlebot" content="index,follow">
<link rel="canonical" href="https://www.phpsciencelabs.com/sunrise-sunset-table-for-today/">

<style type='text/css'>
 BODY
{color:silver; background-color:black;  font-family:Verdana; font-size:100%}

 TABLE
{font-size:12px; border: 1px solid black;}

 TD
{color:black; background-color:white; line-height:200%; font-size:12px;
padding:6px; text-align:center;}

 DIV
{
 color:black; background-color:white; font-family:Verdana; font-size:110%;
 text-align:justify; padding:4px;
}

 PRE
{color:black; background-color:white; font-family:monospace; font-size:150%;
font-weight:bold; text-align:left; padding:4px;}

 CODE
{font-family:monospace; font-size:150%; font-weight:normal;}

 TEXTAREA
{
 color:black; background:white; font-family:monospace; font-size:150%;
 font-weight:bold; border-radius: 8px; border:1px solid black; padding:4px;
 white-space:pre;
}

 INPUT[type="text"]::-ms-clear {width:0; height:0;}

 INPUT[type="text"]
{
 color:black; background:white; font-size:150%; font-family:monospace;
 font-weight:bold; text-align:center; box-shadow:2px 2px 3px #666666;
 border:2px solid black;
}

 INPUT[type="text"]:focus
{
 background:white; box-shadow:2px 2px 3px #666666; font-family:monospace;
 font-size:150%; border:2px solid blue; text-align:center; font-weight:bold;
}

 INPUT[type="submit"]
{font-weight:bold;}

 INPUT[type="submit"]:hover
{box-shadow:2px 2px 5px #555555; font-weight:bold;}

 HR {background:black; height:2px; border:0px;}

 A:link
{
 font-size:100%; background:transparent; color:blue; font-family:Verdana;
 font-weight:bold; text-decoration:none; line-height:175%; padding:3px;
 border:1px solid transparent;
}

 A:visited {font-size:100%; background:transparent; color:blue;}

 A:hover
{
 font-size:100%; background:yellow; color:black; border:1px solid black;
 box-shadow:1px 1px 3px #222222;
}

 A:active  {font-size:100%; background:yellow; color:black;}

::selection      {background-color:yellow; color:black;}
::-moz-selection {background-color:yellow; color:black;}
</style>

</head>

<body>

<form name='form1' method='post' action="$_RUN_">

<table width='800' border='0' cellspacing='1' cellpadding='3'>

<tr><td colspan="$ColSpan" style='color:white; background-color:#000066; border:2px solid white; border-radius:8px 8px 0px 0px;'>$_INTERFACE_TITLE_</td></tr>


<tr>
<td>
Longitude in Degrees (&minus;W / E&plus; ) &nbsp;<input name='LonDeg'  type='text' value="$LonDeg"  size='12' maxlength='11'>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Time Zone Offset From UTC&nbsp; <input name='TZHHMM'  type='text' value="$TZHHMM"  size='7' maxlength='6'>
<br><br>
<b style='color:red;'>NOTE</b>: &nbsp;For correct times, make sure the given longitude and time zone offset are properly matched.
</td>
</tr>




<tr><td colspan="$ColSpan" style='background-color:black;'>
<input name='ComputeButton' type='submit' value=' C O M P U T E '>
</td></tr>



<tr>
<td colspan="$ColSpan" style='background-color:black;'>
<textarea name='TextArea1' color:$TxColor; background:$BgColor; padding:6px; border:2px solid white;' cols="40" rows="$TextArea1Rows" readonly>
$TextArea1Text
</textarea></td>
</tr>





<tr><td colspan="$ColSpan" style='color:gray; background:black;'>Program by $_AUTHOR_<br>$_REVISION_DATE_</td></tr>


</table>
</form>

</body>

</HTML>


_HTML;



// EXTRA UTILITIES

/*
   ============================================================================
   This function converts a time elements string ('h m s') to decimal hours.

   NO DEPENDENCIES
   ============================================================================
*/

   function HMS_to_Hours ($hhmmss)
{
   $hms = StrToLower(trim($hhmmss));

   $hms = Str_Replace('h', ' ', $hms);
   $hms = Str_Replace('m', ' ', $hms);
   $hms = Str_Replace('s', ' ', $hms);
   $hms = Str_Replace(':', ' ', $hms);

   $hms = PReg_Replace("/\s+/", " ", trim($hms));
   $whms = PReg_Split("[ ]", $hms);
   $whmscount = count($whms);
   $hh = ($whmscount >= 1)? bcAdd($whms[0],"0", 20) : "0";
   $mm = ($whmscount >= 2)? bcAdd($whms[1],"0", 20) : "0";
   $ss = ($whmscount >= 3)? bcAdd($whms[2],"0", 20) : "0";

   $NumSign = (substr($hhmmss,0,1) == '-')? '-' : '';
   $hh = Str_Replace('-', '', $hh);
   $hh = Str_Replace('+', '', $hh);

   if (substr($hhmmss,0,1) == '+') {$NumSign = '+';}

   $w2 = bcAdd(bcAdd(bcMul($hh,'3600',20),bcMul($mm,'60',20),20),$ss,20);

   if (bcComp($w2, '0', 20) == 0) {$NumSign = '';}

   $w =  bcAdd(bcDiv($w2,3600, 20), '0.00000000000000005', 16);

   return $NumSign.Rtrim(Rtrim($w, '0'), '.');

} // end of  HMS_to_Hours (hhmmss)

/* ######################################################################## */


/*
   ===========================================================================
   This function returns the equivalent H:M:S time string with
   several formatting options.

   hours         =  Decimal hours value
   ssDecimals    = Number of decimals in seconds part

   posSign = Symbol to use for positive values ('' or '+')
   ''  = Empty = Return numbers only, no symbols.
   '+' = Attach '+' sign to positive values.
   Has no effect on negative values.

   SymbolsMode   = If or not to attach time symbols (h m s) or (:)
   'h' = '01h 02m 03s' (Default)
   ':' = '01:02:03'
   ''  = '01 02 03'

   NO DEPENDENCIES
   ===========================================================================
*/

   function Hours_to_HMS ($hours, $ssDec=0, $posSignSymb='', $SymbMode='h')
{
   $_h_ = $_m_ = $_s_ = '';

   if (trim($posSignSymb) == '')  {$posSignSymb = FALSE;}

   $sign = ($hours < 0)? '-' : '';    $hours = abs($hours);

   if (($posSignSymb === TRUE or $posSignSymb == '+') and $sign == '')
  {$sign = '+';}

   $hh = floor($hours);
   $minutes = 60*($hours - $hh);    $mm = floor($minutes);
   $seconds = 60*($minutes - $mm);  $ss = SPrintF("%1.3f",  $seconds);

   $hh = SPrintF("%02d",  $hh);
   $mm = SPrintF("%02d",  $mm);
   $ss = SPrintF("%1.$ssDec" . "f", $ss);

   if ($ss == 60) {$ss = 0; $mm++;}
   if ($mm == 60) {$mm = 0; $hh++;}

   $hh = SPrintF("%02d",  $hh);
   $mm = SPrintF("%02d",  $mm);

   $ss = SPrintF("%1.$ssDec" . "f", $ss);
   if ($ss < 10) {$ss = "0$ss";}

   if ($SymbMode == 0 or $SymbMode == '')
  {$_h_  =  $_m_  =  $_s_  = ' ';}

   if ($SymbMode == 1 or $SymbMode == ':')
  {$_h_  =  ':';  $_m_  =  ':';  $_s_  = '';}

   if ($SymbMode == 2 or StrToLower($SymbMode) == 'h')
  {$_h_  =  'h ';  $_m_  =  'm ';  $_s_  =  's';}

   $w = "$sign$hh$_h_$mm$_m_$ss$_s_";

   return $w;

} // end of  Hours_to_HMS(...)


/* ######################################################################## */


/*
   ===========================================================================
   This function translates a purely numeric time string into standard form.
   Applies ONLY to purely numerical time strings.

   time format used = 00 to 24 hours

   ----------------------------------
   EXAMPLES
   time String          Translates to
   -----------          -------------
   1                    01:00:00
   12                   12:00:00
   123                  01:23:00
   1234                 12:34:00
   12345                01:23:45
   123456               12:34:56

   This function does NOT check for errors.

   NO DEPENDENCIES
   ===========================================================================
*/

   function Num_to_HMS ($NumHMSVal)
{
   $w = trim($NumHMSVal);

   if ($w == '') {return '00:00:00';}

   if (!Is_Numeric($w)) {return $NumHMSVal;}

   $FirstChar = substr($w,0,1);
   $NumSign   = (IntVal($w) < 0)? '-' : '+';

   $w = Str_Replace($NumSign, '', $w);

   if (StrLen($w) == 1) {$w = "0$w";}
   if (StrLen($w) == 2) {$w = $w."0000";}
   if (StrLen($w) == 3) {$w = "0$w";}
   if (StrLen($w) == 4) {$w = $w."00";}
   if (StrLen($w) == 5) {$w = "0$w";}

   if ($FirstChar <> '+' and $NumSign == '+') {$NumSign = '';}

   return $NumSign.substr($w,0,2).':'.substr($w,2,2).':'.substr($w,4,2);

} // end OF  Num_to_HMS (...)

/* ######################################################################## */


/*
   ============================================
   This function returns a monospaced table of
   sunrise and sunset times for today at the
   given longitude longitude and time zone
   offset from UTC.

   DEPENDENCY:
   HMS_to_Hours()
   Hours_to_HMS()
   ============================================
*/


   function Sunrise_Sunset_Table_For_Today ($LonDeg, $TZHHMM)
{
   $wTable = '';
   $deg    = "&deg;";

   $TZHHMM = trim($TZHHMM);

   $TZOffset = HMS_to_Hours(trim($TZHHMM));
   $TZHHMM = Hours_to_HMS($TZOffset,0,'+', ':');
   $TZHHMM = substr($TZHHMM,0,6);

   for ($LatDeg=65;  $LatDeg >= -65;  $LatDeg--)
{
   $LatStr = SPrintF("%+ 3d", $LatDeg);
   $wTable  .=
   ("$LatStr$deg  sunrise  " . date("Y-M-d-D ") . ''
   . date_sunrise(time(), SUNFUNCS_RET_STRING, $LatDeg, $LonDeg, 89.75, $TZOffset))
   . "\n      "
   . "sunset   " . (date("Y-M-d-D ") . ''
   . date_sunset(time(), SUNFUNCS_RET_STRING, $LatDeg, $LonDeg, 91.25, $TZOffset))
   . "\n\n";
}

   $DateToday = date("Y-M-d-D");

// Replace '+0' with ' 0' within finished table.
   $wTable = Str_Replace('+0', ' 0', $wTable);

   return
"
====================================
Latitudinal Sunrise and Sunset Table

For Date  = $DateToday
Longitude = $LonDeg&deg;
Time Zone = UTC$TZHHMM

Lat    Event       Date and Time
====  ======= ======================
$wTable
   ";

}




/*
   This boolean function checks if
   a given time string is valid.

   Valid time string formats:
   'hh'
   'hh:mm'
   'hh:mm:ss'

   Valid hh = 00 to 24
         mm = 00 to 60
         ss = 00 to 60

   NO DEPENDENCIES

   Returns TRUE if time string is OK.
   Returns FALSE if time string is invalid.

*/

   function Is_Valid_Time ($HHMMSS)
{
   $hhmmss = trim($HHMMSS);

// Error if empty string.
   if ($hhmmss == '') {return FALSE;}

// --------------------------------
// Remove any numerical (-/+) sign.
   $hhmmss = Str_Replace('+', '', Str_Replace('-', '', $hhmmss));

// ----------------------------------------
// Count the time elements (n = 1, 2 or 3).
   $n = 1 + Substr_Count($hhmmss, ':');

// ----------------------------------------------
// Error if more than 3 time (hh:mm:ss) elements.
   if ($n > 3) {return FALSE;}

// ------------------------------------------
// Handle case of 3 time (hh:mm:ss) elements.
   if ($n == 3)
  {
   list($hh,$mm,$ss) = PReg_Split("[\:]", $hhmmss);
   $hh = trim($hh);  $mm = trim($mm);  $ss = trim($ss);

   if (
       !Is_Numeric($hh)
   or  !Is_Numeric($mm)
   or  !Is_Numeric($ss)
   or  $hh > 24  or  $mm > 60 or  $ss > 60
   or  ($hh + $mm/60 + $ss/3600) > 24
      )
      {return FALSE;}
   else
      {return TRUE;}
  }

// --------------------------------------
// Handle case of 2 time (hh:mm) elements.
   if ($n == 2)
  {
   list($hh,$mm) = PReg_Split("[\:]", $hhmmss);
   $hh = trim($hh);  $mm = trim($mm);

   if (
       !Is_Numeric($hh)
   or  !Is_Numeric($mm)
   or  $hh > 24  or  $mm > 60
   or  ($hh + $mm/60) > 24
      )
      {return FALSE;}
   else
      {return TRUE;}
  }

// -----------------------------------
// Handle case of 1 time (hh) element.
   if ($n == 1)
  {
   list($hh) = PReg_Split("[\:]", $hhmmss);

   if (
       !Is_Numeric($hh) or $hh > 24
      )
      {return FALSE;}
   else
      {return TRUE;}
  }

}




?>


